#!/usr/bin/env python

from PCD import Core, PIPFile
import random, os, os.path, sys
from optparse import OptionParser


def parse_opts ():
    parser = OptionParser ()
    parser.add_option ('-o', dest='outfile', default='out.pip',
                        help='Write generated city to FILE', metavar='FILE')
    parser.add_option ('-d', '--dataset', dest='dataset',
                        help='Python module to register dataset', 
                        metavar='FILE')
    parser.add_option ('-v', '--verbose', dest='verbose', action='store_true',
                        default=False, help='Print lots of debugging output')
    return parser.parse_args ()


def building_cb (): 
    sys.stdout.write ('.')
    sys.stdout.flush ()


def main ():
    options,args = parse_opts()

    if not options.dataset:
        print >>sys.stderr, "Error: no dataset specified."
        sys.exit (1)
        
    if options.verbose:
        Core.verbose = True
        callback = building_cb
    else:
        callback = None
    
    if len (args) == 0:
        infile = 'in.pip'
    else:
        infile = args[0]
        
    inscene = PIPFile.Load (infile)
    outscene = Core.processScene (inscene, options.dataset, callback)
    PIPFile.Save (outscene, options.outfile)

    if options.verbose:
        print '\nFinished\n'


if __name__ == '__main__':
    main()
    
