from PCD.Util import XMLParse
from PCD import PIPFile, MetaObject, Registry
import os, os.path


class ParseError(Exception):
    def __init__ (self, val):
        self.value = val
    def __str__ (self):
        return repr (self.val)
        
        
class ObjDefParser (object):

    def __init__ (self, filename, objectdir=''):
        
        self.objects = []
        self.objectdir = objectdir
        
        tree = XMLParse.XMLFileToTree (filename)

        try:
            self._parseObjects (tree)
        except ParseError, e:
            print >>sys.stderr, 'ERROR: Parse error in OBJDEF file '+filename
            raise

        del self.objectdir
        

    ## parse functions
    
    def _parseObjects (self, tree):
        assert tree[0] == 'objects'

        for object in tree[3]:
            self._parseObject (object)

    def _parseObject (self, tree):
        assert tree[0] == 'object'

        name = tree[1]['name']
        src = os.path.join (self.objectdir, tree[1]['src'])
        scene = PIPFile.Load (src)
        o = MetaObject.FromScene (scene, Registry.ObjectName (name))
        self.objects.append ( (o, name) )



def RegisterDir (dirname, registry, objectdir=''):
    
    files = os.listdir (dirname)
    files = filter (lambda s: s[-7:] == '.objdef', files)
    files = [os.path.join (dirname, f) for f in files]
    
    for objdef in files:

        loader = ObjDefParser (objdef, objectdir)

        for obj in loader.objects:
            registry.registerObject (obj[0], obj[1])

