#
# "Persistent" random number generator
# This class operates on named requests. It is guaranteed that two requests
# for the same named request will return the same number.
#

import random


def New ():
    "Returns a new PRand object"
    return PRand ()



class _Request:
    def __init__ (self, name, min, max, isint):
        self._data = name,min,max,isint

    def __hash__ (self):
        return hash (self._data)

    def __eq__ (self, o):
        return self._data == o._data

    def __str__ (self):
        return repr (self._data)

    def __repr__ (self):
        return '_Request('+str(self)+')'



class PRand (object):
    
    def __init__ (self):
        self.requests = {}

    def __str__ (self):
        return str (self.requests)


    def val (self, name, *args):
        """Returns a real number. 
        Arguments are [[min,],max]: min defaults to 0, max defaults to 1"""
        if len (args) == 2:
            min,max = args
        elif len (args) == 1:
            min,max = 0,args[0]
        elif len (args) == 0:
            min,max = 0, 1
        else:
            raise ( ValueError, 'PRand.val accepts 0-2 arguments. ' +
                                '%d supplied.' % len(args) )

        req = _Request (name, min, max, False)
        if req in self.requests:
            return self.requests[req]
        else:
            val = random.uniform (min, max)
            self.requests[req] = val
            return val


    def num (self, name, max):
        "Returns an integer i so that 0<=i<max"
        req = _Request (name, 0, max, True)
        if req in self.requests:
            return self.requests[req]
        else:
            val = random.randrange (max)
            self.requests[req] = val
            return val
        
        
    
