from PCD.Maths.Matrix import *
from PCD.Maths import Vector3D
import unittest


class MatrixTestCase (unittest.TestCase):

    def testDefault (self):
        assert Mat4() == Mat4( [ [1,0,0,0], [0,1,0,0], [0,0,1,0], [0,0,0,1] ] )
    
    def testScalarMult (self):
        a = [ [1, 2, 3, 4], [2, 3, 4, 5], [4, 5, 6, 7], [6, 7, 8, 9] ]
        b = [ [3, 6, 9,12], [6, 9,12,15],[12,15,18,21],[18,21,24,27] ]
        ma = Mat4(a)
        mb = Mat4(b)
        assert ma*3 == mb

    def testMakeTranslation (self):
        v = Vector3D.Vec3 (5,6,7)
        m = Translation ( (8,4,5) )
        assert m == Mat4( [[1,0,0,0],[0,1,0,0],[0,0,1,0],[8,4,5,1]] )
        assert v*m == Vector3D.Vec3(13,10,12)

    def testCallRead (self):
        m = Mat4 ( [ [3, 6, 9,12], [6, 9,12,15],[12,15,18,21],[18,21,24,27] ] )
        assert m(0,0) == 3
        assert m(2,1) == 15
        assert m(3,2) == 24
        


def suite ():
    return unittest.makeSuite (MatrixTestCase)
    

if __name__ == "__main__":
    unittest.main ()

    
