from PCD import PRand
import unittest


class PRandTestCase (unittest.TestCase):

    def testVal01 (self):
        pr = PRand.New ()
        foo = pr.val ('foo')
        assert foo >= 0
        assert foo <= 1
        assert pr.val ('foo') == foo
        
    def testVal0max (self):
        pr = PRand.New ()
        foo = pr.val ('foo', 7)
        assert foo >= 0
        assert foo <= 7
        self.assertEqual (pr.val ('foo', 7), foo)
        assert pr.val ('foo', 7) == foo
        
    def testValminmax (self):
        pr = PRand.New ()
        foo = pr.val ('foo', 3, 15)
        assert foo >= 3
        assert foo <= 15
        assert pr.val ('foo', 3, 15) == foo

    def testValMult (self):
        pr = PRand.New ()
        foo = pr.val ('foo')
        bar = pr.val ('bar', 4)
        baz = pr.val ('baz', 7, 22)
        assert pr.val ('foo') == foo
        assert pr.val ('bar', 4) == bar
        assert pr.val ('baz', 7, 22) == baz

    def testValDef (self):
        pr = PRand.New ()
        assert pr.val ('foo') == pr.val ('foo', 1)
        assert pr.val ('foo') == pr.val ('foo', 0, 1)

    def testNum (self):
        pr = PRand.New ()
        assert pr.num ('bar', 4) == pr.num ('bar', 4)

    def testNumMulti (self):
        pr = PRand.New ()
        foo = pr.num ('foo', 5)
        bar = pr.num ('bar', 12)
        baz = pr.num ('baz', 42)
        assert pr.num ('foo', 5) == foo
        assert pr.num ('bar', 12) == bar
        assert pr.num ('baz', 42) == baz
        


def suite ():
    return unittest.makeSuite (PRandTestCase)
    

if __name__ == "__main__":
    unittest.main ()

    
