from PCD.Architecture import FeatGen, Feature
import random


class BasicDoorFunc (FeatGen.Func):
    "Basic door type- just passes straight through to frame"
    
    def __init__ (self):
        self._regpath = '/features/doors'
        self._regname = 'basic'
        self._regsockets = [ ('frame','/features/door/frames') ]


    def generateContent (self, size, registry, prand, level):
        obj = self.socketGenContent ('frame', size, registry, prand, level)
        hpad = size[0] * random.uniform (0.4,0.6)
        tpad = size[1] * random.uniform (0.4,0.6)
        bpad = prand.val ('bottom-pad', 0.10)
        feat = Feature.New ('door', obj, 'b', (tpad,hpad,bpad,hpad))
        return feat



def Register ():
    return [ BasicDoorFunc() ]


