from PCD import MetaObject, Object
from PCD.Architecture import FeatGen
from PCD.Maths.Vector3D import Vec3



class SimpleDoorObjectFunc (FeatGen.Func):
    "A door in a single quad"

    def __init__ (self):
        self._regpath = '/features/door/objects'
        self._regname = 'simple'
        self._regsockets = [ ('mat', '/materials/doors') ]


    def generateContent (self, size, registry, prand, level):

        w,h = size
        
        o = Object.New ()

        robj = self.chooseSocketValue ('mat', registry, prand)
        o.material = robj.getObject ()

        o.addTri ( [Vec3(0,0,0), Vec3(w,0,0), Vec3(w,h,0)],
                                        ( (0,0), (1,0), (1,1) ) )
        o.addTri ( [Vec3(0,0,0), Vec3(w,h,0), Vec3(0,h,0)],
                                        ( (0,0), (1,1), (0,1) ) )

        return o



def Register ():
    return [ SimpleDoorObjectFunc() ]
