from PCD.Architecture import Feature, FeatureSet, FeatGen


class FeatureRoot (FeatGen.SetGenFunc):
    "Standard set generator point"

    def __init__ (self):
        self._regpath = '/'
        self._regname = 'featureset'
        self._regsockets = [ ('window','/features/windows'),
                             ('door', '/features/doors'),
                             ('ledge', '/features/ledges'),
                             ('roof', '/roofs') ]
                             
        self._socktypes = { 'window' : 'feature',
                            'door' : 'feature',
                            'ledge' : 'feature',
                            'roof' : 'roof' }



    def generateContent (self, required, registry, prand):

        set = FeatureSet.New ()
        
        for rfeat in required:
            stype = self._socktypes[rfeat[1]]
            if stype == 'feature':
                feat = self.socketGenContent (rfeat[1], rfeat[2], 
                                                    registry, prand, 0)
                feat.setName (rfeat[0])
                set.addFeature (rfeat[0], feat)                

            elif stype == 'roof':
                robj = self.chooseSocketValue (rfeat[1], registry, prand)
                rooffunc = robj.getObject ()
                set.setRoofFunc (rooffunc)

            else:
                raise ValueError, "Unknown socket type: "+stype

        return set
            





def Register ():
    return [ FeatureRoot() ]

