from PCD.Architecture import FeatGen, Feature
from PCD.Maths.Vector3D import Vec3
from PCD import Object
import random


class BasicLedgeFunc (FeatGen.Func):
    "Basic ledge type"
    
    def __init__ (self):
        self._regpath = '/features/ledges'
        self._regname = 'basic'
        self._regsockets = [ ('mat','/materials/ledge') ]


    def generateContent (self, size, registry, prand, level):
        # NOTE: size is just the width for ledges
        w = size
        h = prand.val ('ledge-height', 0.3, 0.7)
        d = prand.val ('ledge-depth', 0.08, 0.20)

        o = Object.New ('ledge')
        robj = self.chooseSocketValue ('mat', registry, prand)
        o.material = robj.getObject ()

        # generate the end-caps
        # work out the verts on the left end
        vle = [ Vec3(0,0,0), Vec3(0,0,d), Vec3(0,h,d), Vec3(0,h,0) ]
        # and on the right end
        vre = [ Vec3(w,0,d), Vec3(w,0,0), Vec3(w,h,0), Vec3(w,h,d) ]
        
        # gen the texcoords [same both ends]
        lo = 0.25
        hi = 0.75
        te = [ (0,lo), (d,lo), (d,hi), (0,hi) ]
        
        # add the geometry
        self._genQuad (o, vle, te)
        self._genQuad (o, vre, te)

        # generate the main faces
        vl = vle
        vr = [ v + Vec3(w,0,0) for v in vl ]
        tl = [ (0,0), (0,lo), (0,hi), (0,1) ]
        tr = [ (w,0), (w,lo), (w,hi), (w,1) ]
        self._genQuadStripN (o, vl, vr, tl, tr)
        
        return o



def Register ():
    return [ BasicLedgeFunc() ]



