from PCD.Architecture import FeatGen, Feature
import random


class BasicWindowFunc (FeatGen.Func):
    "Basic window type- just passes straight through to frame"
    
    def __init__ (self):
        self._regpath = '/features/windows'
        self._regname = 'basic'
        self._regsockets = [ ('frame','/features/window/frames') ]


    def generateContent (self, size, registry, prand, level):
        obj = self.socketGenContent ('frame', size, registry, prand, level)
        hpad = size[0] * random.uniform (0.4,0.6)
        vpad = size[1] * random.uniform (0.4,0.6)
        feat = Feature.New ('window', obj, 'c', (vpad,hpad))
        return feat        



def Register ():
    return [ BasicWindowFunc() ]


