from PCD import MetaObject, Object
from PCD.Architecture import FeatGen
from PCD.Maths.Vector3D import Vec3
import random


class BasicWindowGlass (FeatGen.Func):
    "Basic, unadorned pane of glass"
    
    def __init__ (self):
        self._regpath = '/features/window/glass'
        self._regname = 'basic'
        self._regsockets = [ ('mat', '/materials/glass') ]


    def generateContent (self, size, registry, prand, level):

        w,h = size

        pane = Object.New ()
        robj = self.chooseSocketValue ('mat', registry, prand)
        pane.material = robj.getObject ()

        # NOTE: we don't use prand for the offset or all panes are
        #       textured the same...
        tb = random.random ()
        tl = random.random ()
        tt = tb + h*prand.val ('glasstexsize-v', 0.5, 1.2)
        tr = tl + w*prand.val ('glasstexsize-h', 0.5, 1.2)
        
        pane.addTri ( ( Vec3(0,0,0), Vec3(w,0,0), Vec3(w,h,0) ),
                      ( (tl,tb), (tr,tb), (tr,tt) ) )
        pane.addTri ( ( Vec3(0,0,0), Vec3(w,h,0), Vec3(0,h,0) ),
                      ( (tl,tb), (tr,tt), (tl,tt) ) )
        
        return pane


def Register ():
    return [ BasicWindowGlass() ]


