from PCD import Architecture
import random


class MultiDoorStyle (Architecture.Style.Style):
    "A style with a random number of doors"

    def __init__ (self):
	Architecture.Style.Style.__init__ (self)
        self._regname = 'multi-door'

    def _getFeatureList (self):
        win = (random.gauss (1.3,0.2), random.gauss (1.6,0.1))
        door = (random.gauss (1.2,0.2), random.gauss (2.1,0.2))
        return [ ('window','window',win), ('door','door',door),
                 ('roof','roof', None) ]

    def _fillCell (self, row, col, cellbase, facetype):
	if row==0 and random.choice([True,False,False]):
	    self.addFeature ('door', cellbase)
	else:    
	    self.addFeature ('window', cellbase)
	
	
class MultiDoorStyle2 (Architecture.Style.Style):
    "A style with a random number of doors and different windows"

    def __init__ (self):
	Architecture.Style.Style.__init__ (self)
        self._regname = 'multi-door-2'

    def _getFeatureList (self):
        win = (random.gauss (1.3,0.2), random.gauss (1.6,0.1))
        smallwin = (win[0], win[1]*random.uniform(0.6,0.8))
        door = (random.gauss (1.2,0.2), random.gauss (2.1,0.2))
        return [ ('window','window',win), ('smallwindow','window',smallwin),
                 ('door','door',door),
                 ('roof','roof', None) ]

    def _fillCell (self, row, col, cellbase, facetype):
	if row==0:
            if random.choice([True,False,False]):
	        self.addFeature ('door', cellbase)
            else:
	        self.addFeature ('window', cellbase)
	else:    
	    self.addFeature ('smallwindow', cellbase)
	
	

def Register ():
    return [ MultiDoorStyle(), MultiDoorStyle2() ]


